clc
clear
close all

%--------------------------------------------------------------------------
%   Proposal function q(s)
%--------------------------------------------------------------------------

 

alpha=0.4;

beta=0.96;
 


r = @(x)((log(1-x)+alpha*beta/(1-alpha*beta)*log(x))/(1-beta));
 
 
  
n_delta=100;

grid_delta=(linspace(0.01,0.99,n_delta))';


K_delta=zeros(n_delta,3);
 


for i=1:n_delta
    
    delta=grid_delta(i);
    
    s_r=alpha*beta;
    s_m=alpha*delta*beta/(1-alpha*beta+alpha*delta*beta);
    s_o=alpha*delta*beta/((1-beta+delta*beta)*(1-alpha*beta)+alpha*delta*beta);
   
    
    h = @(x)((1-beta+delta*beta)/(1-beta)*log(1-x)+delta*alpha*beta/(1-alpha*beta)/(1-beta)*log(x));

    h_m=h(s_m); 

    if (h_m>h(s_r))

        s_t=fsolve(@(x)h(x)-h_m,alpha*beta);

    else

        s_t=s_r;

    end     
    
    K_delta(i,1)=s_o^(1/(1-alpha));
    K_delta(i,2)=s_r^(1/(1-alpha));
    K_delta(i,3)=s_m^(1/(1-alpha));
    K_delta(i,4)=s_t^(1/(1-alpha));
     
end



 
%==========================================================================

 

% Create figure
figure1 = figure;

% Create axes
axes1 = axes('Parent',figure1);

%xlim(axes1,[1 16]);
ylim(axes1,[0  1.1]);
box(axes1,'on');
hold(axes1,'all'); 

% Create multiple lines using matrix input to plot
plot1 = plot(grid_delta,K_delta(:,1:3)/K_delta(1,2),'MarkerSize',4,'LineWidth',3,'Color',[0 0 0],...
    'Parent',axes1);
set(plot1(1),'LineWidth',2,'Color',[    0.8500    0.3250    0.0980] );
set(plot1(2),'LineStyle','--','Color',[0    0.4470    0.74100]);
set(plot1(3),'LineStyle','-.');
%set(plot1(4),'LineStyle',':');
 



xlabel('$$\delta$$','interpreter','latex','FontSize',14);
ylabel('Capital $k$','interpreter','latex','FontSize',14);


I = legend('Organizational equilibrium', 'Ramsey outcome', 'Markov equilibrium');


set(I,'interpreter','latex'); %set Latex interpreter
set(I,'FontWeight','bold','FontSize',14,'Location','Best');
set(I,'FontName','Times New Roman');
set(I,'box','Off');
 
 